#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>


#define MIN2(x,y) ((x)<(y))?(x):(y)

// Basic Data Structure.
struct data {
    char *name1,*name2;
    double score;
  int  x1,y1,x2,y2,sign,keep,touched;
};

// list of data ( change to dynamic after)
int maxsize   = 1000;
int totalsize = 0;

struct data* list;
int factor = 6;
int maxtouched = 5;
float lenfraction = 0.8;

// output data structure
void print(struct data D){
  char c = (D.sign > 0)? '+' : '-';
  printf("%s %d %d; ", D.name1,D.x1,D.x2);
  printf("%s %d %d; ",D.name2,D.y1,D.y2);
  printf("score = %.4f (%c)\n",D.score, c);
}

// output data list
void printlist(){
    int i=0;
    for ( i=0; i < totalsize; i++ )
    	print(list[i]);
}

// output data list
void printactivelist(){
    int i=0;
    for ( i=0; i < totalsize; i++ )
       if( list[i].keep == 1 && list[i].touched < maxtouched )
    	print(list[i]);
}

// Get Line
int getline(){
    // variables
    int i=0;
    char * token[10]={0};
    char* pch;
    // test input
    char line[150]={0};
    
    //get the input
    if(( fgets(line,150,stdin) == NULL ) || ( line[0]=='\n' ))
       return 0;

    //tokenize input
    pch = strtok (line," ");
    while (pch != NULL){
          token[i++]=pch;
          pch = strtok (NULL, " ");
    }

    // remove ; from input
    token[2][strlen(token[2])-1]='\0';
    token[5][strlen(token[5])-1]='\0';

     
    //add to list of structures   
    list[totalsize].name1 = malloc(100);
    list[totalsize].name2 = malloc(100);  
    
    //copy tokens over - (modify to use dynamic memory after)
    strcpy(list[totalsize].name1,token[0]);strcpy(list[totalsize].name2,token[3]);  
    list[totalsize].x1 = atoi(token[1]); list[totalsize].x2 = atoi(token[2]);    
    list[totalsize].y1 = atoi(token[4]); list[totalsize].y2 = atoi(token[5]);
    list[totalsize].score = atof(token[8]); list[totalsize].keep = 1;
    list[totalsize].touched = 0;
        
    // get sign
    if( token[9][1] == '-')
         list[totalsize].sign = -1;
    else list[totalsize].sign = +1;
    totalsize++;
    // dynamically allocate the memory.

    if( totalsize >= maxsize ) {
       list   = (struct data*) realloc ( list, ( maxsize *=2 ) * sizeof(struct data));
       assert (list);       
    }
    
    return 1;

}

// used for quicksort for X axis (ignoring name for now)
int compareX (const void * a, const void * b){
  struct data * A = (struct data*)a;
  struct data * B = (struct data*)b;
  int rv = strcmp(A->name1, B->name1);
  if (rv) return rv;
  if (A->x1 >  B->x1) { return +1; }
  if (A->x1 == B->x1) { return 0;  } // should sort y1,x2,y2 (later).
  if (A->x1 <  B->x1) { return -1; }
}

// used for quicksort for Y axis (ignoring name for now)
int compareY (const void * a, const void * b){
  struct data * A = (struct data*)a;
  struct data * B = (struct data*)b;
  int rv = strcmp(A->name1, B->name1);
  if (rv) return rv;
  if (A->y1 >  B->y1) { return +1; }
  if (A->y1 == B->y1) { return 0;  } // should sort y1,x2,y2 (later).
  if (A->y1 <  B->y1) { return -1; }
}

// remove the index from the list of active inputs 
int disactivate(int index){
   list[index].keep = 0;   
}

// filter x axis
int filterXaxis(){   
   
   int curI;
   int closeJ;
   float covered, lenI, lenJ;

   qsort( list, totalsize, sizeof(struct data), compareX);

   for( curI = 0; curI < totalsize; curI++ )  {
       if( list[curI].keep == 1)
	for( closeJ = curI+1; closeJ < totalsize; closeJ++ ){
	    if( list[closeJ].keep == 1)    {
		// break no more touching
		if( list[closeJ].x1 > list[curI].x2 )  break;

		// so compare the curI and closeJ
		lenJ = list[closeJ].x2 - list[closeJ].x1;
		lenI = list[curI].x2 - list[curI].x1;
		covered = MIN2(list[curI].x2, list[closeJ].x2) - list[closeJ].x1;

		if (covered/lenJ > lenfraction) {
		  list[closeJ].touched++;
		  if( list[closeJ].score * factor < list[curI].score )
		    disactivate(closeJ);
		}

		if (covered/lenI > lenfraction) {
		  list[curI].touched++;
		  if( list[closeJ].score > factor*list[curI].score ){
		    disactivate(curI);
		    break;
		  }
		}
	    }
	}
   }
}

// filter y axis
int filterYaxis(){   
   
   int curI;
   int closeJ;
   float covered, lenI, lenJ;

   qsort( list, totalsize, sizeof(struct data), compareY);

   for( curI = 0; curI < totalsize; curI++ )  {
       if( list[curI].keep == 1)
	for( closeJ = curI+1; closeJ < totalsize; closeJ++ ){
	    if( list[closeJ].keep == 1)    {
		// break no more touching
		if( list[closeJ].y1 > list[curI].y2 )  break;
		
		lenJ = list[closeJ].y2 - list[closeJ].y1;
		lenI = list[curI].y2 - list[curI].y1;
		covered = MIN2(list[curI].y2, list[closeJ].y2) - list[closeJ].y1;

		// so compare the curI and closeJ
		if (covered/lenJ > lenfraction) {
		  list[closeJ].touched++;
		  if( list[closeJ].score * factor < list[curI].score )
		    disactivate(closeJ);
		}

		if (covered/lenI > lenfraction) {
		  list[curI].touched++;
		  if( list[closeJ].score > factor*list[curI].score ){
		    disactivate(curI);
		    break;
		  }
		}
	    }
	}
   }
}

// Main Body
int main (){

  list = malloc (maxsize * sizeof(struct data));
  // read
  while( getline() == 1 );
  // filter
  filterXaxis();
  filterYaxis();
  // output
  //printlist();  
  printactivelist();
  return 0;
}

